POJ3285 River Hopscotch(最大化最小值之二分查找)

POJ3285 River Hopscotch

  此题是大白P142页(即POJ2456)的一个变形题,典型的最大化最小值问题.

  C(x)表示要求的最小距离为X时,此时需要删除的石子.二分枚举X,直到找到最大的X,由于c(x)=m时满足题意,所以最后输出的是ub-1或者lb(lb==ub-1

  注意相邻距离小于x的要删除(此处不是小于等于),对于相邻的距离小于x的两个石子,当删除其中一个后,又会产生其他的相邻的石子,直接计数不好计数,不妨用两个标记last,cur,其中last表示上一个石子,cur表示当前的石子

    将起点的石子和终点的石子加入数组,距离分别初始化为0,1,让last=0,cur=last+1=1开始,由于起点和终点不能删除,每次只需判断cur是否需要删除,若需要,cur++;

再次循环时,last=cur,cur=last+1,对于循环的终止条件,当cur=n+1时,若a[cur]-a[last]<x(此时last一定不为0),前面一直删除的是右边的,此处其实删除的是左边的,对结果没影响,此时cur++,cur的值变为n+2,跳出最内层循环,再跳出外层循环.

注意 last一定不为0的假设是基于n!=0的假设,当n=0时,可以单独判断一下.当n=0时,mid会一直减小到l,所以下面程序也没问题

我一开始把 int c(x) 函数写成了bool类型,在调试时又把INF改小了,后来交上去就一直wa,其实不需要将ub初始化为INF,直接初始化为l+1就够了

以下为AC代码

/*
* Created:     2016年03月31日 16时07分30秒 星期四
* Author:      Akrusher
*
*/
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <ctime>
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <deque>
#include <list>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <numeric>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <fstream>
using namespace std;
#define rep(i,a,n) for (int i=a;i<n;i++)
#define per(i,a,n) for (int i=n-1;i>=a;i--)
#define in(n) scanf("%d",&(n))
#define in2(x1,x2) scanf("%d%d",&(x1),&(x2))
#define inll(n) scanf("%I64d",&(n))
#define inll2(x1,x2) scanf("%I64d%I64d",&(x1),&(x2))
#define inlld(n) scanf("%lld",&(n))
#define inlld2(x1,x2) scanf("%lld%lld",&(x1),&(x2))
#define inf(n) scanf("%f",&(n))
#define inf2(x1,x2) scanf("%f%f",&(x1),&(x2))
#define inlf(n) scanf("%lf",&(n))
#define inlf2(x1,x2) scanf("%lf%lf",&(x1),&(x2))
#define inc(str) scanf("%c",&(str))
#define ins(str) scanf("%s",(str))
#define out(x) printf("%d\n",(x))
#define out2(x1,x2) printf("%d %d\n",(x1),(x2))
#define outf(x) printf("%f\n",(x))
#define outlf(x) printf("%lf\n",(x))
#define outlf2(x1,x2) printf("%lf %lf\n",(x1),(x2));
#define outll(x) printf("%I64d\n",(x))
#define outlld(x) printf("%lld\n",(x))
#define outc(str) printf("%c\n",(str))
#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define SZ(x) ((int)(x).size())
#define mem(X,Y) memset(X,Y,sizeof(X));
typedef vector<int> vec;
typedef long long ll;
typedef pair<int,int> P;
const int dx[4]={1,0,-1,0},dy[4]={0,1,0,-1};
const int INF=0x3f3f3f3f;
const ll mod=1e9+7;
ll powmod(ll a,ll b) {ll res=1;a%=mod;for(;b;b>>=1){if(b&1)res=res*a%mod;a=a*a%mod;}return res;}
const bool AC=true;

int l,n,m,cnt;
int a[50005];
int C(int x){ //返回值是int类型,不是bool类型
    cnt=0;
    int last,cur;
    last=0;
    while(true){
    cur=last+1;
    if(cur>=n+2) break;
    while(a[cur]-a[last]<x){
    cnt++;
    cur++;
    if(cur==n+2) break;
    }
    last=cur;
  }
  return cnt;
}
int main()
{
    in2(l,n);
    in(m);
    a[0]=0;//a[0]=0为起点
    rep(i,1,n+1){
        in(a[i]);
        }
    a[n+1]=l; //a[n+1]为终点
    sort(a,a+n+2);
    int lb,ub,mid;
    lb=0,ub=l+1;//设为l+1可以减小查找时间
    while(ub-lb>1){
    mid=(ub+lb)/2;
    if(C(mid)>m) ub=mid;//距离大了
    else if(C(mid)<=m) lb=mid;
    }
    out(lb);//或者out(ub-1);
    return 0;
}
时间: 2024-10-12 12:31:03

POJ3285 River Hopscotch(最大化最小值之二分查找)的相关文章

LeetCode Find Minimum in Rotated Sorted Array 旋转序列找最小值(二分查找)

题意:有一个有序序列A,其内部可能有部分被旋转了,比如A[1...n]被转成A[mid...n]+A[1...mid-1],如果被旋转,只有这种形式.问最小元素是?(假设没有重复元素) 思路:如果是序没乱,直接返回A[1],如果乱了,二分查找还是可以的,O(1)可能就不行了. 二分要点:mid有可能就是所要找的最小元素,所以不能轻易写出l=mid+1这样的语句,可能最小值就被忽略过了,因为我们无法直接判断A[mid]是否就是最小值.所以尽量应该是l=mid这样写,但是要防止死循环. 具体来说,可

POJ 3258 River Hopscotch (最大最小距离)【二分】

<题目链接> 题目大意:现在有起点和终点两个石块,这两个石块之间有N个石块,现在对这N个石块移除M个石块,使得这些石块之间的最短距离最大,注意,起点和终点这两个石块不能被移除. 解题分析: 二分答案典型题,二分最大的最短距离,然后根据这个最短距离对这些石块从左向右进行判断,用一个last记录每一次判断的起点,如果当前石块到last的距离<=最短距离,说明该木块需要被移除.对于最后一个石块,由于最后一个石块不能被移除,所以加入最后一个石块到last的距离<=mid,那么就直接移除la

[ACM] POJ 3258 River Hopscotch (二分,最大化最小值)

River Hopscotch Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 6697   Accepted: 2893 Description Every year the cows hold an event featuring a peculiar version of hopscotch that involves carefully jumping from rock to rock in a river. T

River Hopscotch(二分最大化最小值)

River Hopscotch Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 9923   Accepted: 4252 Description Every year the cows hold an event featuring a peculiar version of hopscotch that involves carefully jumping from rock to rock in a river. T

River Hopscotch-[二分查找、贪心]

Description Every year the cows hold an event featuring a peculiar version of hopscotch that involves carefully jumping from rock to rock in a river. The excitement takes place on a long, straight river with a rock at the start and another rock at th

POJ 3258 River Hopscotch 二分答案

River Hopscotch Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 6193   Accepted: 2685 Description Every year the cows hold an event featuring a peculiar version of hopscotch that involves carefully jumping from rock to rock in a river. T

poj 3258 River Hopscotch 【二分】

题目真是不好读,大意如下(知道题意就很好解了) 大致题意: 一条河长度为 L,河的起点(Start)和终点(End)分别有2块石头,S到E的距离就是L. 河中有n块石头,每块石头到S都有唯一的距离 问现在要移除m块石头(S和E除外),每次移除的是与当前最短距离相关联的石头,要求移除m块石头后,使得那时的最短距离尽可能大,输出那个最短距离. //Memory Time //420K 391MS #include<iostream> #include<algorithm> using

POJ 3258 River Hopscotch(二分&#183;最小距离最大)

题意  一条河两岸之间有n个石头  求取走m个石头后  使得两个石头间距离的最小值最大 感觉关键是理解题意  简单的二分  二分最小距离  看要取走多少个(cnt)石头  cnt<=m的话 说明最小距离还可以增大  这样就可以二分出答案了 #include <cstdio> #include <algorithm> using namespace std; const int N = 50005; int p[N], l, n, m; bool ok(int k) { int

最大值最小化问题 和最小值最大化问题 ---(二分)

最大值最小化 即是当存在一个x为最大值的最小化,则x-1不成立,x+1可行,但他不满足最小,所以设边界最小值L,最大值R,二分查找第一个满足题意的, 例子: 把一个包含n个正整数的序列划分成m个连续的子序列.设第i个序列的各数之和为S(i),求所有S(i)的最大值最小是多少? 例如序列1 2 3 2 5 4划分为3个子序列的最优方案为 1 2 3 | 2 5 | 4,其中S(1),S(2),S(3)分别为6,7,4,那么最大值为7: 如果划分为 1 2 | 3 2 | 5 4,则最大值为9,不是